define([
    "../../../widgets/ListWidget",
    "../../../widgets/_ComplexValueWidget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/text!./templates/MultipleChoiceInputConfigRowWidget.html",
    "dojo/text!./templates/MultipleChoiceInputConfigWidget.html"
], function(ListWidget, _ComplexValueWidget, _TemplatedMixin, _WidgetBase, _WidgetsInTemplateMixin, declare, event, lang, domConstruct, rowTemplate, template) {

    var Row = declare([_ComplexValueWidget],{
        templateString: rowTemplate,
        onDestroy: function(evt) {}
    });
    
    return declare([_ComplexValueWidget],{
        type: 'MultipleChoiceInput',
        templateString: template,
        buildRendering: function() {
            this.inherited(arguments);
            this.itemsWidget = new ListWidget({
                name: "items",
                type: "MultipleChoiceItem",
                skipForm: true,
                delay: 5,
                createListElement: lang.hitch(this, "_createRow"),
                createAvatar: lang.hitch(this, "_createAvatar")
            }, this.itemsNode);
        },
        _createRow: function(id, item) {
            var widget = new Row({
                id: id,
                value: item,
                onDestroy: lang.hitch(this,function(evt){
                    this.itemsWidget.removeItem(id,true);
                    if ( evt ) { event.stop(evt); }
                    return false;
                })
            });
            widget.startup();
            return widget;
        },
        _createAvatar: function(id, item) {
            return domConstruct.create("div", {
                innerHTML: item.text || "(empty)"
            });
        },
        _getValueAttr: function() {
            var value = this.inherited(arguments);
            value.type = this.type;
            value.allowMultiple = value.allowMultiple.length > 0;
            return value;
        },
        _setValueAttr: function(value) {
            value.allowMultiple = value.allowMultiple ? ["on"] : [];
            return this.inherited(arguments);
        },
        onAddItem: function(evt) {
            this.itemsWidget.appendItem({},true);
            if ( evt ) { event.stop(evt); }
            return false;
        }
    });
});
